
/* AVATARS WIDGET *** Creator/author Sean Bischoff 2006 avatarswidget@yahoo.com

V1.0.2 6/16/06 - Corrected API URL in update fn to point to img1
V1.0.1 6/15/06 - numbers in ID bug fix, captions default to off


*/

//widget logic
    
    // Load the last saved, until update is complete.
    // Saved avatar is updated everytime the widget avatar is updated.
    myAvatar.missingSrc = "Resources/missing.png";
    if(preferences.myYID.value=="" && preferences.buddyYID.value=="") {
      myAvatar.src = myAvatar.missingSrc;
      missingBlurbTitle.visible = true;
      missingBlurb.visible = true;
      showWidgetPreferences();
    }
    function testConnection() {
      testconnurl = new URL();
      avString = buildAvString();
      //old dcn servers not reliable
      //avtaddress = "http://img.avatars.yahoo.com/bimages.php?nobg" + avString;
      //mud is safe
      avtaddress = "http://img1.avatar.vip.mud.yahoo.com/bimages.php?nobg" + avString;
      avttestconn = testconnurl.fetch(avtaddress);
      if (( testconnurl.response != 200 || testconnurl.result == "Could not load URL"))
      { return false; }
      else
      { return true; }
    }
    
    
    function updateAvatars(){
      
      //If connection exists and we have a user ID, GET a new png with latest avatars
      if ((testConnection()) && (preferences.myYID.value!=""))
      {
          buildAvString(); //collect params for API string
          if(preferences.myYID.value != "") {
            myAvatar.loadingSrc = system.widgetDataFolder + "/savedavatar.png";
          } else {
            myAvatar.loadingSrc = myAvatar.missingSrc;
          }
          myAvatar.src = "http://img1.avatar.vip.mud.yahoo.com/bimages.php?nobg&" + avString;
          myAvatar.reload(); //reload widget image
          saveAvatar('temp'); //save the widget image for offline use
          myAvatar.visible=true;
          missingBlurbTitle.visible = false;
          missingBlurb.visible = false;
          
      }
      else
      { 
        //No connection, can't get image from API. Load saved img if it exists.
        if( (filesystem.itemExists(system.widgetDataFolder + "/savedavatar.png") ) && (preferences.myYID.value!="") ){
          myAvatar.src = system.widgetDataFolder + "/savedavatar.png";
          missingBlurbTitle.visible = false;
          missingBlurb.visible = false;
          
        }
        else {
         //No local savedavatar.png, widget probably being run for first time.
          myAvatar.src = myAvatar.missingSrc;
          missingBlurbTitle.visible = true;
          missingBlurb.visible = true;
          myName.visible = false;
          
        }
      }
      
      if(preferences.myYID.value) {
        myAvatar.height =  preferences.avatarSize.value;
        myAvatar.width = myAvatar.height / .75;
      }
      
      if (preferences.reposprefAvatar.value==1) {
        repositionAvatar();
        preferences.reposprefAvatar.value=0;
      }
      if(preferences.showText.value!="no") { 
        myName.size = myAvatar.height * .08; 
        myName.vOffset = myAvatar.height * .99 + 15 * (myAvatar.height/225);
        myName.color = preferences.textColor.value;
        myName.alignment= "center";
        myName.width = main_window.width;  
        if(preferences.showText.value=="yid") { 
          myName.alignment= "center"; 
        }
        if(preferences.showText.value=="cc"){ 
          if(preferences.cbScrollCaption.value == 1) {
            myName.scrolling = "autoleft";
            myName.alignment= "left";
          }
          else {
            myName.scrolling = "off";
            myName.truncation = "end";
            myName.alignment= "center";
          }
        }
        
        myName.bgColor = preferences.captionBgColor.value;
        myName.bgOpacity = preferences.captionBgOpacity.value;
        
        if(preferences.shadowMyText.value == 1){
          myName.shadow = null;
        }
        else {
          var sm = new Shadow();
          sm.hOffset = 1;
          sm.vOffset = 1;
          sm.color = preferences.shadowColor.value; //"#8B2A90";
          myName.shadow = sm;
        }
        
        if(preferences.showText.value=="yid") {
          myName.data = makeYIDstring(" & ");
        }
        else if (preferences.showText.value=="cc") {
          myName.data = preferences.customCaption.value;
        }

      myName.visible = true;
      }
      else {
        myName.data="";
      }
    }
    
    updateAvatars();
    
    
    function saveAvatar(sType) {
      var url = new URL();
      switch(sType) {
      case 'temp':
        url.outputFile = system.widgetDataFolder + "/savedavatar.png";
        url.location = myAvatar.src;
        url.fetch();
      break;
      case 'mydoc':
        url.outputFile = saveAs(".png");
        (url.outputFile.search(".png")== -1) ? url.outputFile = url.outputFile + ".png" : "";
        url.location = myAvatar.src;
        url.fetch();
      break;
      }
      
    }
    
    
    function repositionAvatar() {
      //Restore shunken avatar that disappeared offstage
      main_window.hOffset = 0 + screen.availLeft;
  		main_window.vOffset = 0 + screen.availTop;
    }
    
    
    function goAvatarsSite() {
      intlprefix = preferences.pickIntl.value;
      (intlprefix=="us") ? intlprefix="" : intlprefix = intlprefix + ".";
      intlURL = "http://" + intlprefix + "avatars.yahoo.com";
      openURL(intlURL);
    }


    //called at onload to check connection status, and by update()
    function buildAvString() {
      yidsURLstring = makeYIDstring(",");
      tavString = "yids=" + yidsURLstring;
      
      ymoodsURLstring = makeMoodString(",");
      tavString = tavString + ymoodsURLstring;
      
      if(preferences.myYID.value!="") {
        if(preferences.buddyYID.value!="") {
          tavString = tavString + "&sep=" + preferences.buddyDistance.value;
        }
        tavString = tavString + "&pty=23000&.src=ywdgt";
        return tavString;
      }  
    }


    //used by updateAvatars() and buildAvString()
    function makeYIDstring(delin) {
    //  check for more than one ID (CSV attempt)
    // 	ID may consist of a-z, 0-9, underscores, and a single dot (.)
    //  strip out 2nd or more
    var regexp = /[, :]/
    
    var matchMy = preferences.myYID.value.search(regexp);
    if (matchMy >0) {
      preferences.myYID.value = preferences.myYID.value.slice(0,matchMy);
    }
    var matchBuddy = preferences.buddyYID.value.search(regexp);
    if (matchBuddy >0) {
      preferences.buddyYID.value = preferences.buddyYID.value.slice(0,matchBuddy);
    }
    
    yid1 = preferences.buddyYID.value;
    
      if(preferences.swapPlaces.value == 1) { //put me on right and buddy on left
        yid1 = preferences.buddyYID.value;
        yid2 = preferences.myYID.value;
      }
      else {
        yid1 = preferences.myYID.value;
        yid2 = preferences.buddyYID.value;
      }
      if( (yid1=="") || (yid2=="") ) {
        delin = "";
      }
      returnString = yid1 + delin + yid2;
      return returnString;
      //prefix 'yids' is not added here because other actions use this function, not just the string builder
    }


    //used by buildAvString()
    //this is a separate fn from makeYIDstring since each handles delin independantly
    function makeMoodString(delin) {
      if(preferences.swapPlaces.value == 1) { //put me on right and buddy on left
        mood1 = (preferences.buddyYID.value) ? preferences.buddyMood.value : "no";
        mood2 = (preferences.myYID.value) ? preferences.myMood.value : "no" ;
      }
      else {
        mood1 = (preferences.myYID.value) ? preferences.myMood.value : "no";
        mood2 = (preferences.buddyYID.value) ? preferences.buddyMood.value : "no";
      }
      
      returnString2 = "&moods=" + mood1 + delin + mood2;
      return returnString2;
    }

    
    function refreshUpdateAvatars(){
      //only update if myYID is entered
      if(preferences.myYID.value) {
        updateAvatars();
      }
      else {
        myName.alignment = "center";
        myName.visible = false;
        myAvatar.src = myAvatar.missingSrc;
        missingBlurbTitle.visible = true;
        missingBlurb.visible = true;
        
      }
    }
    
